                                  ;   PIC16F676 
                                  ;  LED c OK
  
     
 processor 16F676
  include  <p16f676.inc> 
 __CONFIG   _CP_OFF & _CPD_OFF & _BODEN_OFF & _MCLRE_ON & _WDT_OFF & _PWRTE_ON & _INTRC_OSC_NOCLKOUT 
                         ; 3F24h 

  org    .0
  goto  MAIN
    
  errorlevel-302
  CBLOCK  20H



; 
        ;    ( )
ind_1	        
ind_2	       
ind_3  

catodNo     ;    3 2 1 0
      ;   
Led2
Led1
Led0
Hi
Lo
Pam
LOOP1
LOOP2
count1  	;     
count2  
FLAG
   ENDC

;-------------------------------------------------------------------------------------------------------
MAIN
	    bcf	      	STATUS, RP0          ;   0
	    clrf	PORTC
	    clrf        PORTA
	    movlw      	.7                   ;   
            movwf      	CMCON                ; 
	    bsf	    	STATUS,RP0           ;   1
	    movlw	b'10001000'
            movwf      	OPTION_REG	        
            movlw      	0x50 
	    ;call	0x3FF
	    movwf	OSCCAL
	    clrf	ANSEL
	    movlw	b'00010000'           ; RA4   
	    movwf	TRISA                 ;   
	    clrf	TRISC                 ;   
	    bcf	       	STATUS,RP0            ;   0
	   
            clrf    	ind_1
            clrf    	ind_2
            clrf    	ind_3
            movlw    	.1
            movwf    	catodNo
            goto     	CYCLE
           
        ;          
;-----------------------------------------------------------------------------------------------
MASKA:
                andlw   0x0F	        ;
       	        addwf   PCL,f
;  5   4   3   2  1   0
;  5   6   7   8  9   10
;  f   e   d   c   b   a        
; g-RA5 =  6 -  G,  7  1
                retlw	b'10111111'       ;  0 
	        retlw	b'10000110'       ;  1 
	        retlw	b'11011011'       ;  2 
	        retlw	b'11001111'       ;  3 
	        retlw	b'11100110'       ;  4 
	        retlw	b'11101101'       ;  5 
	        retlw	b'11111101'       ;  6 
	        retlw	b'10000111'       ;  7 
	        retlw	b'11111111'       ;  8 
	        retlw	b'11101111'       ;  9

	        

                                          ;   

CYCLE
                    ;     
;---------------------------------------------------------------------------
        bsf	  STATUS, RP0  
        movlw     b'00010000'       ;   
        movwf     ADCON1
        movlw     b'0010000'        ; AN3 
        movwf     ANSEL            
        bcf	  STATUS, RP0 
        movlw     b'10001101'       ;   ,  AN3,
        movwf     ADCON0            ; F/8
        movlw 	  .2                ;      
        call      DELAY_10USEC      ;  C_ hold   
        bsf       ADCON0, 1   	    ;  
        btfsc     ADCON0, 1  	    ;  ?
        goto      $-1               ; , 
        movfw  	  ADRESH      	    ;  , 
        movwf  	  Hi       	    ;   
        bsf	  STATUS,RP0        ;   1- 
        movfw  	  ADRESL
        bcf       STATUS, RP0  	    ;   0- 
        movwf     Lo
        bcf       ADCON0, ADON      ;  
     ;==================================================
        call    b2_10
      	movlw     .250              
	movwf	  count1	    ;    (250     1)
        movwf     count2
    
ms500
        movlw     .200
        call      DELAY_10USEC
       
                    ;  1 ,    
;------------------------------------------------------------------------------------------------

;    
;       
;  RA   3     2      1      0
               
m12   
          bcf     STATUS,C
          rrf     catodNo,f         ;  cAtodNo  2 -> 1 -> 0
          bnc     Nextanod          ;     ,   
          bsf     catodNo, 2        ;    ,  cAtodNo=4, 
         							;   
          movlw   catodNo           ;     
          movwf   FSR               ;    
Nextanod
          bcf     PORTA, 0 
          bcf     PORTA, 1 
          bcf     PORTA, 2 
              
          decf    FSR,f            ;     e
          movfw   INDF             ;       
          movwf   PORTC            ;      
          movfw   catodNo
          movwf   PORTA            ;    
    
          btfss   INDF, 6
          goto    m_G
          bsf     PORTA, 5
          goto    m14
m_G
          bcf     PORTA, 5  
m14     
          btfsc   FLAG, 1       ;    count1 ?
          GOTO    m1            ; ,   ,   count2
	  decfsz  count1,f 	; ,  1 ,     500 , 
	  goto	  ms500		;     0,5 
          bsf     FLAG, 1       ;     count1
m1
          decfsz  count2,f      ;   250  
          goto    ms500         ;    
          bcf     FLAG, 1       ;     count1
        
                       ;  501 ,          
                       ;      
        ;==========================================================
             
       
        movfw	Led2
        call	MASKA
        movwf   ind_1		 
              
        movfw	Led1
        call	MASKA	
        movwf   ind_2

        movfw	Led0
	call	MASKA
	movwf   ind_3
	goto    CYCLE 

                             ; 
;===========================================================================
b2_10
           clrf       Pam
          
;   Led2
;-------------------------------------------------------------
            clrf        Led2	;  Led2 ()
M300        
            movlw       .3
            addwf       Led2, F
            movlw       0x2C	;    300 H'012C'
            subwf       Lo, F
            rlf         Pam, W
            sublw       0x02	;    300+1
            subwf       Hi, F
            btfsc       STATUS, C
            goto        M300
            movlw       .100	;  .100
M100        
            decf        Led2, F
            addwf       Lo, F
            btfss       STATUS, C
            goto        M100
            incf         Hi, F
            btfsc       Hi,7
            goto        M100
;   Led1
            clrf        Led1
            movlw       .30	;  .30
M30         incf        Led1, F
            subwf       Lo, F
            btfsc       STATUS, C
            goto        M30
            movf        Led1, W
            rlf         Led1, F
            addwf       Led1, F
            movlw       .10	;  .10
M10         decf        Led1, F
            addwf       Lo, F
            btfss       STATUS, C
            goto        M10
;   Led0
            movf        Lo, W
            movwf       Led0
            return
 
;---------------------------------------

DELAY_10USEC:   	;   W * 10 
        MOVWF 	LOOP1
DELAY_10USEC_1:
        NOP
        NOP
        NOP
        NOP
        NOP
        NOP
        NOP
        DECFSZ 	LOOP1, F
        GOTO 	DELAY_10USEC_1
        RETURN


        END

          






